## zug 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
cmake_policy(SET CMP0048 NEW) # enable project VERSION
cmake_policy(SET CMP0056 NEW) # honor link flags in try_compile()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

project(zug VERSION 0.1.0)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
set(CMAKE_EXPORT_COMPILE_COMMANDS on)
set(CMAKE_CXX_EXTENSIONS off)
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
endif()

option(zug_BUILD_TESTS "Build tests" ON)
option(zug_BUILD_EXAMPLES "Build examples" ON)
option(zug_BUILD_DOCS "Build docs" ON)

#  Targets
#  =======

# ccache support
find_program(CCACHE ccache)
if (CCACHE)
  message(STATUS "Using ccache: ${CCACHE}")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
else()
  message(STATUS "Could not find ccache")
endif()

# the library
add_library(zug INTERFACE)
target_include_directories(zug INTERFACE
  $<BUILD_INTERFACE:${zug_BINARY_DIR}/>
  $<BUILD_INTERFACE:${zug_SOURCE_DIR}/>
  $<INSTALL_INTERFACE:include>)

install(TARGETS zug EXPORT ZugConfig)
install(EXPORT ZugConfig DESTINATION lib/cmake/Zug)
install(DIRECTORY zug DESTINATION include)

enable_testing()
add_custom_target(check
  COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  COMMENT "Build and run all the tests and examples.")

# the library, local development target
if(zug_BUILD_TESTS)
  add_library(zug-dev INTERFACE)
  target_include_directories(zug-dev SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${zug_SOURCE_DIR}/>/tools/include")
  target_link_libraries(zug-dev INTERFACE zug)
  if (ENABLE_COVERAGE)
    target_compile_options(zug-dev INTERFACE "--coverage")
    target_link_libraries(zug-dev INTERFACE "--coverage")
  endif()

  add_subdirectory(test)
endif()

if(zug_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

if (zug_BUILD_DOCS)
  add_subdirectory(doc)
endif()

=== doc/CMakeLists.txt ===

#  Targets
#  =======

add_custom_target(doxygen
  COMMAND doxygen doxygen.config
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")

add_custom_target(docs
  COMMAND make html
  WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}/doc")
add_dependencies(docs doxygen)

set(zug_ssh_method
  ssh -p 5488
      -o StrictHostKeyChecking=no
      -i ${CMAKE_SOURCE_DIR}/tools/travis/ssh-key)

add_custom_target(upload-docs
  COMMAND
  rsync -av -e \"${zug_ssh_method}\"
        ${CMAKE_SOURCE_DIR}/doc/_build/html/*
        raskolnikov@sinusoid.es:public/zug/)

=== test/CMakeLists.txt ===
#  Utils
#  =====

function(zug_target_name_for out_target out_file file)
  get_filename_component(_extension ${_file} EXT)

  file(RELATIVE_PATH _relative ${CMAKE_CURRENT_SOURCE_DIR} ${file})
  string(REPLACE "${_extension}" "" _name ${_relative})
  string(REGEX REPLACE "/" "-" _name ${_name})
  set(${out_target} "test-${_name}" PARENT_SCOPE)

  string(REPLACE "${_extension}" "" _name ${_relative})
  string(REGEX REPLACE "/" "-" _name ${_name})
  set(${out_file} "${_name}" PARENT_SCOPE)
endfunction()

#  Targets
#  =======

add_custom_target(tests COMMENT "Build all the unit tests.")
add_dependencies(check tests)

add_subdirectory(__inline_var_tests)

file(GLOB_RECURSE zug_unit_tests "*.cpp")
list(FILTER zug_unit_tests EXCLUDE REGEX "${CURRENT_CMAKE_DIRECTORY}/__*")

foreach(_file IN LISTS zug_unit_tests)
  message("found unit test: " ${_file})
  zug_target_name_for(_target _output "${_file}")
  add_executable(${_target} EXCLUDE_FROM_ALL "${_file}")
  set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
  add_dependencies(tests ${_target})
  target_compile_definitions(${_target} PUBLIC CATCH_CONFIG_MAIN)
  target_link_libraries(${_target} PUBLIC zug-dev)
  add_test("test/${_output}" ${_output})
endforeach()

=== debian/changelog ===
zug (0.1.0-2~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 05 Oct 2023 12:48:36 -0700

zug (0.1.0-2) unstable; urgency=medium

  * Upload to unstable.
  * update-catch2.diff: mention https://github.com/arximboldi/zug/pull/36 that
    will fix the issue in the long term.

 -- Pino Toscano <pino@debian.org>  Sun, 06 Aug 2023 22:04:48 +0200

zug (0.1.0-1) experimental; urgency=medium

  * Initial packaging.

 -- Pino Toscano <pino@debian.org>  Fri, 28 Jul 2023 13:47:27 +0200

=== debian/control ===
Source: zug
Section: libs
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: cmake (>= 3.8~), debhelper-compat (= 13), libboost-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/arximboldi/zug
Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/zug
Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/zug.git

Package: libzug-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libboost-dev, ${misc:Depends}
Description: C++ library providing transducers -- development files
 zug is a C++ library providing transducers. Transducers are composable
 sequential transformations independent of the source. They are extremely
 lightweight, and can be used to express algorithms over pull-based sequences
 (iterators, files) but also push based sequences (signals, events,
 asynchronous streams) in a generic way.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -Dzug_BUILD_EXAMPLES=OFF \
	  -Dzug_BUILD_DOCS=OFF

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif

# No dbgsym packages:
override_dh_strip:
	dh_strip --no-automatic-dbgsym

## zug 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,16 +6,24 @@
 project(zug VERSION 0.1.0)
 
 set(CMAKE_CXX_STANDARD 14)
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
 set(CMAKE_EXPORT_COMPILE_COMMANDS on)
 set(CMAKE_CXX_EXTENSIONS off)
 if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments")
 endif()
 
+include(GNUInstallDirs)
+
+option(DISABLE_WERROR "enable --werror")
+
 option(zug_BUILD_TESTS "Build tests" ON)
 option(zug_BUILD_EXAMPLES "Build examples" ON)
 option(zug_BUILD_DOCS "Build docs" ON)
+
+if (NOT MSVC AND NOT DISABLE_WERROR)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
+endif()
 
 #  Targets
 #  =======
@@ -35,11 +43,11 @@
 target_include_directories(zug INTERFACE
   $<BUILD_INTERFACE:${zug_BINARY_DIR}/>
   $<BUILD_INTERFACE:${zug_SOURCE_DIR}/>
-  $<INSTALL_INTERFACE:include>)
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)
 
 install(TARGETS zug EXPORT ZugConfig)
-install(EXPORT ZugConfig DESTINATION lib/cmake/Zug)
-install(DIRECTORY zug DESTINATION include)
+install(EXPORT ZugConfig DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/Zug")
+install(DIRECTORY zug DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
 
 enable_testing()
 add_custom_target(check
@@ -49,9 +57,9 @@
 
 # the library, local development target
 if(zug_BUILD_TESTS)
+  find_package(Catch2 REQUIRED)
+
   add_library(zug-dev INTERFACE)
-  target_include_directories(zug-dev SYSTEM INTERFACE
-    "$<BUILD_INTERFACE:${zug_SOURCE_DIR}/>/tools/include")
   target_link_libraries(zug-dev INTERFACE zug)
   if (ENABLE_COVERAGE)
     target_compile_options(zug-dev INTERFACE "--coverage")

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -32,6 +32,6 @@
   set_target_properties(${_target} PROPERTIES OUTPUT_NAME ${_output})
   add_dependencies(tests ${_target})
   target_compile_definitions(${_target} PUBLIC CATCH_CONFIG_MAIN)
-  target_link_libraries(${_target} PUBLIC zug-dev)
+  target_link_libraries(${_target} PUBLIC zug-dev Catch2::Catch2)
   add_test("test/${_output}" ${_output})
 endforeach()

=== test/__inline_var_tests/CMakeLists.txt ===

#  Targets
#  =======

message("adding unit test: inline_var_tests")

file(GLOB_RECURSE inline_var_test_files "*.cpp")
add_executable(inline_var_tests EXCLUDE_FROM_ALL ${inline_var_test_files})
add_dependencies(tests inline_var_tests)
target_link_libraries(inline_var_tests PUBLIC zug-dev)
add_test("test/inline_var_tests" inline_var_tests)

=== debian/changelog ===
zug (0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - update-catch2.diff: drop, the embedded copy of doctest was dropped
  * Update the build dependencies according to the upstream build system:
    - add catch2
  * Update copyright.
  * Pass -DDISABLE_WERROR=ON to cmake to not use -Werror when building.
  * Disable the tests for now: they assume Catch2 v2.x, and v3 requires changes.

 -- Pino Toscano <pino@debian.org>  Sun, 15 Oct 2023 20:51:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,12 @@
 Source: zug
 Section: libs
 Priority: optional
-Maintainer: Steven Pusser <stevep@mxlinux.org>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Pino Toscano <pino@debian.org>
-Build-Depends: cmake (>= 3.8~), debhelper-compat (= 13), libboost-dev
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Pino Toscano <pino@debian.org>,
+Build-Depends: catch2,
+               cmake (>= 3.8~),
+               debhelper-compat (= 13),
+               libboost-dev,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://github.com/arximboldi/zug
@@ -15,7 +17,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libboost-dev, ${misc:Depends}
+Depends: ${misc:Depends},
+         libboost-dev,
 Description: C++ library providing transducers -- development files
  zug is a C++ library providing transducers. Transducers are composable
  sequential transformations independent of the source. They are extremely

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- \
	  -DDISABLE_WERROR=ON \
	  -Dzug_BUILD_TESTS=OFF \
	  -Dzug_BUILD_EXAMPLES=OFF \
	  -Dzug_BUILD_DOCS=OFF

ifeq (disabledfornow,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build:
	dh_auto_build -- tests
endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/arximboldi/zug/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## zug 0.1.2

=== doc/CMakeLists.txt ===

#  Targets
#  =======

add_custom_target(doxygen
  COMMAND doxygen doxygen.config
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")

add_custom_target(docs
  COMMAND make html
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
add_dependencies(docs doxygen)

add_custom_target(upload-docs
  COMMAND
  rsync -av ${CMAKE_CURRENT_SOURCE_DIR}/_build/html/*
        root@sinusoid.es:/var/lib/syncthing/public/zug/)

=== debian/changelog ===
zug (0.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.3, no changes required.
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Drop Priority: optional, no more needed since dpkg 1.22.13.
  * Update the build dependencies according to the upstream build system:
    - bump cmake to 3.10

 -- Pino Toscano <pino@debian.org>  Thu, 15 Jan 2026 06:52:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: zug
 Section: libs
-Priority: optional
 Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Pino Toscano <pino@debian.org>,
 Build-Depends: catch2,
-               cmake (>= 3.8~),
+               cmake (>= 3.10~),
                debhelper-compat (= 13),
                libboost-dev,
-Standards-Version: 4.6.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://github.com/arximboldi/zug
 Vcs-Browser: https://salsa.debian.org/qt-kde-team/3rdparty/zug
 Vcs-Git: https://salsa.debian.org/qt-kde-team/3rdparty/zug.git
